package JointFeldmanProtocol;

import Communication.MailHandler;
import Communication.MessageHandler;
import com.google.protobuf.InvalidProtocolBufferException;
import com.google.protobuf.Message;
import meerkat.protobuf.DKGMessages;

/**
 * Created by Tzlil on 2/29/2016.
 */
public class DistributedKeyGenerationMailHandler extends MailHandler {

    public DistributedKeyGenerationMailHandler(MessageHandler messageHandler) {
        super(messageHandler);
    }

    @Override
    public Message extractMessage(DKGMessages.Mail mail) {
        try {
            Message message;
            switch (mail.getType()) {
                case SECRET:
                    message = DKGMessages.SecretMessage.parseFrom(mail.getMessage());
                    break;
                case COMMITMENT:
                    message = DKGMessages.CommitmentMessage.parseFrom(mail.getMessage());
                    break;
                case COMPLAINT:
                    message = DKGMessages.ComplaintMessage.parseFrom(mail.getMessage());
                    break;
                case DONE:
                    message = DKGMessages.DoneMessage.parseFrom(mail.getMessage());
                    break;
                case ANSWER:
                    message = DKGMessages.SecretMessage.parseFrom(mail.getMessage());
                    break;
                default:
                    return null;
            }
            return message;
        } catch (InvalidProtocolBufferException e) {
            return null;
        }
    }
}
